"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var broccoli_sass_compiler_1 = require("./broccoli_sass_compiler");
var crypto = require("crypto");
var merge = require("lodash.merge");
var path = require("path");
var sortby = require("lodash.sortby");
var stringify = require("json-stable-stringify");
var debugGenerator = require("debug");
var Eyeglass = require("eyeglass");
var sass = require("node-sass");
var dependencyTree = require("dependency-tree");
var assetImportCacheDebug = debugGenerator("broccoli-eyeglass:asset-import-cache");
var dependencyDebug = debugGenerator("broccoli-eyeglass:file-dependencies");
var CURRENT_VERSION = require(path.join(__dirname, "..", "package.json")).version;
function httpJoin() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var joined = [];
    for (var i = 0; i < args.length; i++) {
        if (args[i]) {
            var segment = args[i];
            if (path.sep !== "/") {
                segment = segment.replace(path.sep, "/");
            }
            joined.push(segment);
        }
    }
    var result = joined.join("/");
    result = result.replace("///", "/");
    result = result.replace("//", "/");
    return result;
}
var EyeglassCompiler = /** @class */ (function (_super) {
    __extends(EyeglassCompiler, _super);
    function EyeglassCompiler(inputTrees, options) {
        var _this = this;
        options = merge({}, options);
        if (!Array.isArray(inputTrees)) {
            inputTrees = [inputTrees];
        }
        var configureEyeglass, assetDirectories, assetsHttpPrefix;
        if (options.configureEyeglass) {
            configureEyeglass = options.configureEyeglass;
            delete options.configureEyeglass;
        }
        var relativeAssets = options.relativeAssets;
        delete options.relativeAssets;
        if (options.assets) {
            assetDirectories = options.assets;
            if (typeof assetDirectories === "string") {
                assetDirectories = [assetDirectories];
            }
            delete options.assets;
        }
        if (options.assetsHttpPrefix) {
            assetsHttpPrefix = options.assetsHttpPrefix;
            delete options.assetsHttpPrefix;
        }
        _this = _super.call(this, inputTrees, options) || this;
        _this.configureEyeglass = configureEyeglass;
        _this.relativeAssets = relativeAssets;
        _this.assetDirectories = assetDirectories;
        _this.assetsHttpPrefix = assetsHttpPrefix;
        _this.events.on("compiling", _this.handleNewFile.bind(_this));
        _this._assetImportCacheStats = {
            hits: 0,
            misses: 0,
        };
        return _this;
    }
    EyeglassCompiler.prototype.handleNewFile = function (details) {
        var _this = this;
        var options = details.options;
        if (!options.eyeglass) {
            options.eyeglass = {};
        }
        if ((this.assetsHttpPrefix || this.relativeAssets) && !options.eyeglass.assets) {
            options.eyeglass.assets = {};
        }
        if (this.assetsHttpPrefix) {
            options.eyeglass.assets.httpPrefix = this.assetsHttpPrefix;
        }
        if (this.relativeAssets) {
            options.eyeglass.assets.relativeTo = httpJoin(options.eyeglass.httpRoot || "/", path.dirname(details.cssFilename));
        }
        options.assetsCache = this.cacheAssetImports.bind(this);
        options.eyeglass.buildDir = details.destDir;
        options.eyeglass.engines = options.eyeglass.engines || {};
        options.eyeglass.engines.sass = options.eyeglass.engines.sass || sass;
        options.eyeglass.installWithSymlinks = true;
        options.eyeglass.buildCache = this.buildCache;
        var eyeglass = new Eyeglass(options);
        if (this.assetDirectories) {
            for (var i = 0; i < this.assetDirectories.length; i++) {
                eyeglass.assets.addSource(path.resolve(eyeglass.options.eyeglass.root, this.assetDirectories[i]), {
                    globOpts: {
                        ignore: ["**/*.js", "**/*.s[ac]ss"],
                    },
                });
            }
        }
        if (this.configureEyeglass) {
            this.configureEyeglass(eyeglass, options.eyeglass.engines.sass, details);
        }
        // set up asset dependency tracking
        eyeglass.assets.resolver(function (filepath, fullUri, realResolve, cb) {
            _this.events.emit("dependency", filepath).then(function () {
                realResolve(filepath, fullUri, cb);
            }, cb);
        });
        eyeglass.assets.installer(function (file, uri, realInstall, cb) {
            realInstall(file, uri, function (error, destFile) {
                if (error) {
                    cb(error, file);
                }
                else {
                    _this.events.emit("additional-output", destFile, uri, file).then(function () {
                        cb(null, file);
                    }, cb);
                }
            });
        });
        details.options = eyeglass.options;
        details.options.eyeglass.engines.eyeglass = eyeglass;
    };
    EyeglassCompiler.prototype.cachableOptions = function (rawOptions) {
        rawOptions = merge({}, rawOptions);
        delete rawOptions.file;
        if (rawOptions.eyeglass) {
            delete rawOptions.eyeglass.engines;
            delete rawOptions.eyeglass.modules;
        }
        return rawOptions;
    };
    EyeglassCompiler.currentVersion = function () {
        return CURRENT_VERSION;
    };
    EyeglassCompiler.prototype.dependenciesHash = function (_srcDir, _relativeFilename, options) {
        var _this = this;
        if (!this._dependenciesHash) {
            var eyeglass = new Eyeglass(options);
            var hash_1 = crypto.createHash("sha1");
            hash_1.update("broccoli-eyeglass@" + EyeglassCompiler.currentVersion());
            var egModules = sortby(eyeglass.modules.list, function (m) { return m.name; });
            egModules.forEach(function (mod) {
                var name = mod.name;
                if (mod.inDevelopment || mod.eyeglass.inDevelopment) {
                    var depHash = _this.hashForJs(mod);
                    hash_1.update(name + "@" + depHash);
                }
                else {
                    var version = mod.version || "<unversioned>";
                    hash_1.update(name + "@" + version);
                }
            });
            this._dependenciesHash = hash_1.digest("hex");
        }
        return this._dependenciesHash;
    };
    EyeglassCompiler.prototype.keyForSourceFile = function (srcDir, relativeFilename, options) {
        var key = _super.prototype.keyForSourceFile.call(this, srcDir, relativeFilename, options);
        var optsString = stringify(this.cachableOptions(options));
        var dependencies = this.dependenciesHash(srcDir, relativeFilename, options);
        return key + "+" + optsString + "+" + dependencies;
    };
    // Cache the asset import code that is generated in eyeglass
    EyeglassCompiler.prototype.cacheAssetImports = function (key, getValue) {
        // if this has already been generated, return it from cache
        var assetImportKey = "assetImport(" + key + ")";
        var assetImport = this.buildCache.get(assetImportKey);
        if (assetImport !== undefined) {
            assetImportCacheDebug("cache hit for key '%s'", key);
            this._assetImportCacheStats.hits += 1;
            return assetImport;
        }
        assetImportCacheDebug("cache miss for key '%s'", key);
        this._assetImportCacheStats.misses += 1;
        assetImport = getValue();
        this.buildCache.set(assetImportKey, assetImport);
        return assetImport;
    };
    EyeglassCompiler.prototype.hashForJs = function (mod) {
        var e_1, _a;
        var jsPath = mod.mainPath;
        if (!jsPath) {
            return "";
        }
        var cacheKey = "hashForJs(" + jsPath + ")";
        var cachedHash = this.buildCache.get(cacheKey);
        if (cachedHash) {
            return cachedHash;
        }
        var files = dependencyTree.toList({ filename: jsPath, directory: path.dirname(jsPath) });
        dependencyDebug(jsPath + " => \n\t" + files.join("\n\t"));
        var hash = crypto.createHash("sha1");
        try {
            for (var files_1 = __values(files), files_1_1 = files_1.next(); !files_1_1.done; files_1_1 = files_1.next()) {
                var file = files_1_1.value;
                hash.update(file);
                hash.update(this.fileKey(file));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (files_1_1 && !files_1_1.done && (_a = files_1.return)) _a.call(files_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var result = hash.digest("base64");
        this.buildCache.set(cacheKey, result);
        return result;
    };
    return EyeglassCompiler;
}(broccoli_sass_compiler_1.default));
module.exports = EyeglassCompiler;
//# sourceMappingURL=index.js.map